export interface PersonalNumberOptions {
    normaliseFormat?: string;
    strict?: boolean;
    forgiving?: boolean;
}
export interface PersonalNumberReturn {
    valid: boolean;
    type?: PersonalNumberType;
    input: string;
    normalised?: string;
    date?: Date;
    age?: number;
    gender?: Gender;
    birthplace?: BirthPlace;
    reason?: PersonalNumberErrors;
}
export declare enum Gender {
    Male = "MALE",
    Female = "FEMALE"
}
export declare enum PersonalNumberType {
    PersonalNumber = "PERSONNUMMER",
    CoordinationNumber = "SAMORDNINGSNUMMER",
    IndividualCompany = "ENSKILD_FIRMA"
}
export declare enum BirthPlace {
    Stockholm = "Stockholms l\u00E4n",
    Uppsala = "Uppsala l\u00E4n",
    Sodermansland = "S\u00F6dermanlands l\u00E4n",
    Ostergotland = "\u00D6sterg\u00F6tlands l\u00E4n",
    Jonkoping = "J\u00F6nk\u00F6pings l\u00E4n",
    Kronoberg = "Kronobergs l\u00E4n",
    Kalmar = "Kalmar l\u00E4n",
    Gotland = "Gotlands l\u00E4n",
    Blekinge = "Blekinge l\u00E4n",
    Kristianstad = "Kristianstads l\u00E4n",
    Malmohus = "Malm\u00F6hus l\u00E4n",
    Halland = "Hallands l\u00E4n",
    GoteborgBohus = "G\u00F6teborgs och bohus l\u00E4n",
    Alvsborg = "\u00C4lvsborgs l\u00E4n",
    Skaraborg = "Skaraborgs l\u00E4n",
    Varmland = "V\u00E4rmlands l\u00E4n",
    Extranummer = "Extranummer",
    Orebro = "\u00D6rebro l\u00E4n",
    Vastmanland = "V\u00E4stmanlands l\u00E4n",
    Kopparberg = "Kopparbergs l\u00E4n",
    Gavleborg = "G\u00E4vleborgs l\u00E4n",
    Vasternorrland = "V\u00E4sternorrlands l\u00E4n",
    Jamtland = "J\u00E4mtlands l\u00E4n",
    Vasterbotten = "V\u00E4sterbottens l\u00E4n",
    Norrbotten = "Norrbottens l\u00E4n",
    ExtranummerImmigrerad = "Extranummer (immigrerade)"
}
export declare enum PersonalNumberErrors {
    InputType = "INPUT_TYPE",
    Format = "FORMAT",
    Checksum = "CHECKSUM",
    IncorrectDate = "INCORRECT_DATE",
    AgeSeparatorContradiction = "AGE_SEPARATOR_CONTRADICTION",
    BackToTheFuture = "BACK_TO_THE_FUTURE"
}
